package com.alterdekim.flash.decompiler.translator;

import com.alterdekim.flash.decompiler.action.ByteCodeAction;
import lombok.extern.slf4j.Slf4j;

import java.util.*;

@Slf4j
public class Java2Flash {
    private Set<String> pool;

    public List<ByteCodeAction> convert(Map<String, Object> map) {
        this.pool = new HashSet<>(65535);
        extractAllStrings(map);
        log.info("poolSet: {}", this.pool);
        return new ArrayList<>();
    }

    private void extractAllStrings(Map<String, Object> map) {
        map.keySet().forEach(k -> {
            if(k.matches("[^0-9].+")) {
                pool.add(k);
            }
        });
        map.values().forEach(o -> {
            switch( o.getClass().getSimpleName() ) {
                case "HashMap":
                    extractAllStrings((HashMap<String, Object>) o);
                    break;
                case "String":
                    pool.add((String) o);
                    break;
            }
        });
    }
}
