package com.alterdekim.flash.decompiler.util;

import lombok.extern.slf4j.Slf4j;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.Arrays;

@Slf4j
public class ByteUtil {
    public static int bytesToInt(byte[] bytes) {
        int value = 0;
        for (byte b : bytes) {
            value = (value << 8) + (b & 0xFF);
        }
        return value;
    }

    public static int bytesToIntRev(byte[] bytes) {
        int value = 0;
        for(int i = bytes.length-1; i >= 0; i-- ) {
            value = (value << 8) + (bytes[i] & 0xFF);
        }
        return value;
    }

    public static double bytesToDouble(byte[] bytes) {
        byte[] b1 = new byte[8];
        for( int i = bytes.length-1, u = 0; i >= 0; i--, u++ ) {
            b1[u] = bytes[i];
        }
        byte[] d = new byte[8];
        System.arraycopy(Arrays.copyOfRange(b1, 4, 8), 0, d, 0, 4);
        System.arraycopy(Arrays.copyOfRange(b1, 0, 4), 0, d, 4, 4);
        return ByteBuffer.wrap(d).order(ByteOrder.BIG_ENDIAN).getDouble();
    }
}
